#include <time.h>   
#include <stdio.h>   
#include <sys/types.h>   
#include <sys/socket.h>   
#include <netinet/in.h>   
#include <arpa/inet.h>   
#include <unistd.h>   
#include <errno.h>   
#include <string.h>   
#include <stdlib.h>
#include <string>   
#include <map>
#include <vector>
#include "FPGAMsgProtocol.h"
  
using namespace std;
  
#define SERV_PORT 50060
#define MULTI_ADDR "224.0.0.10"
#define LOCAL_ADDR "192.168.2.131"

int handleMDMsg(const char *inBuf, const int &bufSize);

int handleSZSEIndexMD(const CSZSEIndexMDField *msg);
int handleSZSETradeMD(const CSZSETradeMDField *msg);
int handleSZSEOrderMD(const CSZSEOrderMDField *msg);
int handleSZSEStockMD(const CSZSEStockMDField *msg);
int handleSZSEOptionMD(const CSZSEOptionMDField *msg);

int handleSSEIndexMD(const CSSEIndexMDField *msg);
int handleSSETradeMD(const CSSETradeMDField *msg);
int handleSSEOrderMD(const CSSEOrderMDField *msg);
int handleSSESnapMD(const CSSESnapMDField *msg);
int handleSSEOptionMD(const CSSEOptionMDField *msg);
int handleSSENewBondSnapMD(const CSSENewBondSnapMDField *msg);
int handleSSENewBondTickMD(const CSSENewBondTickMDField *msg);

int handleSZSEIndexMD(const CSZSEIndexMDField *msg)
{
        char strSecurityID[9] = {'\0'};
        strncpy(strSecurityID, msg->mSecurityID, 6);
	printf("SecurityID=%s,OrigTime=%ld,LastIndex=%ld,HighIndex=%ld,LowIndex=%ld,OpenIndex=%ld.\n", strSecurityID, msg->mOrigTime, msg->mLast, msg->mHigh, msg->mLow, msg->mOpen);
	return 0;
} 

int handleSZSETradeMD(const CSZSETradeMDField *msg)
{
        char strSecurityID[9] = {'\0'};
        strncpy(strSecurityID, msg->mSecurityID, 6);
	printf("SecurityID=%s,ChannelNo=%d,MDStreamID=%s,BidApplSeqNum=%ld,OfferApplSeqNum=%ld,LastPx=%ld,LastQty=%ld.\n", strSecurityID, msg->mChannelNo, msg->mMDStreamID, msg->mBidApplSeqNum, msg->mOfferApplSeqNum, msg->mLastPx, msg->mLastQty);
	return 0;
} 

int handleSZSEOrderMD(const CSZSEOrderMDField *msg)
{
        char strSecurityID[9] = {'\0'};
        strncpy(strSecurityID, msg->mSecurityID, 6);
	printf("SecurityID=%s,ChannelNo=%d,MDStreamID=%s,ApplSeqNum=%ld,Price=%ld,OrderQty=%ld.\n", strSecurityID, msg->mChannelNo, msg->mMDStreamID, msg->mApplSeqNum, msg->mPrice, msg->mOrderQty);
	return 0;
} 

int handleSZSEStockMD(const CSZSEStockMDField *msg)
{
        char strSecurityID[9] = {'\0'};
        strncpy(strSecurityID, msg->mSecurityID, 6);
        printf("SecurityID=%s,OrigTime=%ld,ChannelNo=%d,Last=%ld,Open=%ld,High=%ld,Low=%ld,UpperLimit=%ld,LowerLimit=%ld,Bid1Price=%ld,Bid1Volume=%ld,Bid10Price=%ld,Bid10Volume=%ld.\n", 
		strSecurityID, msg->mOrigTime, msg->mChannelNo, msg->mLast, msg->mOpen, msg->mHigh, msg->mLow, msg->mUpperLimit, msg->mLowerLimit, msg->mBidDepthMD[0].mPrice, msg->mBidDepthMD[0].mVolume, msg->mBidDepthMD[9].mPrice, msg->mBidDepthMD[9].mVolume);
        return 0;
}

int handleSZSEOptionMD(const CSZSEOptionMDField *msg)
{
        char strSecurityID[9] = {'\0'};
        strncpy(strSecurityID, msg->mSecurityID, 6);
        printf("SecurityID=%s,OrigTime=%ld,ChannelNo=%d,Last=%ld,Open=%ld,High=%ld,Low=%ld,UpperLimit=%ld,LowerLimit=%ld,Bid1Price=%ld,Bid1Volume=%ld,Bid10Price=%ld,Bid10Volume=%ld.\n", 
		strSecurityID, msg->mOrigTime, msg->mChannelNo, msg->mLast, msg->mOpen, msg->mHigh, msg->mLow, msg->mUpperLimit, msg->mLowerLimit, msg->mBidDepthMD[0].mPrice, msg->mBidDepthMD[0].mVolume, msg->mBidDepthMD[9].mPrice, msg->mBidDepthMD[9].mVolume);
        return 0;
}

int handleSSEIndexMD(const CSSEIndexMDField *msg)
{
	printf("SecurityID=%s,UpdateTime=%d,LastIndex=%ld,HighIndex=%ld,LowIndex=%ld,OpenIndex=%ld,TurnOver=%ld.\n", msg->mSecurityID, msg->mUpdateTime, msg->mLast, msg->mHigh, msg->mLow, msg->mOpen, msg->mTurnOver);
	return 0;
} 

int handleSSETradeMD(const CSSETradeMDField *msg)
{
	printf("SecurityID=%s,UpdateTime=%d,TradeIndex=%d,TradeChannel=%d,LastPx=%ld,LastQty=%ld,TurnOver=%ld,BizIndex=%ld.\n", 
	msg->mSecurityID, msg->mUpdateTime, msg->mTradeIndex, msg->mTradeChannel, msg->mPrice, msg->mTradeVolume, msg->mTurnOver,msg->mBizIndex);
	return 0;
} 

int handleSSEOrderMD(const CSSEOrderMDField *msg)
{
	printf("SecurityID=%s,UpdateTime=%d,OrderIndex=%d,OrderChannel=%d,OrderPrice=%ld,BizIndex=%ld.\n", 
	msg->mSecurityID, msg->mUpdateTime, msg->mOrderIndex, msg->mOrderChannel, msg->mOrderPrice, msg->mBizIndex);
	return 0;
} 

int handleSSESnapMD(const CSSESnapMDField *msg)
{
        printf("SecurityID=%s,UpdateTime=%ld,Last=%d,Open=%d,High=%d,Low=%d,TurnOver=%ld,Bid1Price=%d,Bid1Volume=%ld,Bid10Price=%d,Bid10Volume=%ld.\n",
msg->mSecurityID, msg->mUpdateTime, msg->mLast, msg->mOpen, msg->mHigh, msg->mLow, msg->mTurnOver, msg->mDepthMDField[0].mPrice, msg->mDepthMDField[0].mVolume, msg->mDepthMDField[9].mPrice, msg->mDepthMDField[9].mVolume);
        return 0;
}

int handleSSEOptionMD(const CSSEOptionMDField *msg)
{
        printf("SecurityID=%s,UpdateTime=%d,Last=%f,Open=%f,High=%f,Low=%f,TurnOver=%f,LastUpdateTime=%d,Bid1Price=%f,Bid1Volume=%ld,Bid10Price=%f,Bid10Volume=%ld.\n",
msg->mSecurityID, msg->mUpdateTime, msg->mLast, msg->mOpen, msg->mHigh, msg->mLow, msg->mTurnOver, msg->mLastUpdateTime, msg->mDepthMDField[0].mPrice, msg->mDepthMDField[0].mVolume, msg->mDepthMDField[9].mPrice, msg->mDepthMDField[9].mVolume);
        return 0;
}

int handleSSENewBondSnapMD(const CSSENewBondSnapMDField *msg)
{
        printf("NewBondSnapSecurityID=%s,UpdateTime=%ld,Last=%d,Open=%d,High=%d,Low=%d,TurnOver=%ld,Bid1Price=%d,Bid1Volume=%ld,Bid10Price=%d,Bid10Volume=%ld.\n",
msg->mSecurityID, msg->mUpdateTime, msg->mLast, msg->mOpen, msg->mHigh, msg->mLow, msg->mTurnOver, msg->mDepthMDField[0].mPrice, msg->mDepthMDField[0].mVolume, msg->mDepthMDField[9].mPrice, msg->mDepthMDField[9].mVolume);
        return 0;
}

int handleSSENewBondTickMD(const CSSENewBondTickMDField *msg)
{
        printf("NewBondTickSecurityID=%s,TickTime=%ld,BuyOrderNo=%1d,SellOrderNo=%1d,Price=%ld,mQty=%ld,TradeMoney=%ld,TickBSFlag=%s.\n",
msg->mSecurityID, msg->mTickTime, msg->mBuyOrderNo, msg->mSellOrderNo, msg->mPrice, msg->mQty, msg->mTradeMoney, msg->mTickBSFlag);
        return 0;
}

int handleMDMsg(const char *inBuf, const int &bufSize)
{
	int gmdHdrLen = sizeof(CGMDHeader);
	int offset    = 0;
	while(offset + gmdHdrLen -1 < bufSize)
	{
		CGMDHeader *gmdHdr = (CGMDHeader*) (inBuf+offset);
		if(offset + gmdHdrLen + gmdHdr->mBodyLen -1 < bufSize)
		{
			switch(gmdHdr->mMsgID)
			{
				case 0x0D01:	handleSSEIndexMD(&(((CGMDMsgSSEIndexMD*)gmdHdr)->mGMDField));	break;
				case 0x0D02:
				case 0x0D03:
				case 0x0D04:	handleSSESnapMD(&(((CGMDMsgSSESnapMD*)gmdHdr)->mGMDField));		break;
				case 0x0D05:	handleSSEOptionMD(&(((CGMDMsgSSEOptionMD*)gmdHdr)->mGMDField));	break;
				case 0x0D06:	handleSSETradeMD(&(((CGMDMsgSSETradeMD*)gmdHdr)->mGMDField));	break;
				case 0x0D0C:	handleSSEOrderMD(&(((CGMDMsgSSEOrderMD*)gmdHdr)->mGMDField));	break;
				case 0x0D11:	handleSZSEIndexMD(&(((CGMDMsgSZSEIndexMD*)gmdHdr)->mGMDField));	break;
				case 0x0D12:	handleSZSEStockMD(&(((CGMDMsgSZSEStockMD*)gmdHdr)->mGMDField));	break;
				case 0x0D13:	handleSZSEOptionMD(&(((CGMDMsgSZSEOptionMD*)gmdHdr)->mGMDField));	break;
				case 0x0D14:	handleSZSETradeMD(&(((CGMDMsgSZSETradeMD*)gmdHdr)->mGMDField));	break;
				case 0x0D15:	handleSZSEOrderMD(&(((CGMDMsgSZSEOrderMD*)gmdHdr)->mGMDField));	break;
				case 0x0D31:  handleSSENewBondSnapMD(&(((CGMDMsgSSENewBondSnapMD*)gmdHdr)->mGMDField));	break;
				case 0x0D32:  handleSSENewBondTickMD(&(((CGMDMsgSSENewBondTickMD*)gmdHdr)->mGMDField));	break;
				default:	printf("Error::GMD MsgID(0x%x) is not correct.\n", gmdHdr->mMsgID); break;
			}
			offset += gmdHdrLen + gmdHdr->mBodyLen; 
		}
		else
		{
			//printf("Info::%d Bytes not handled...\n", bufSize-offset-1);
			break;
		}
	}
	if(bufSize - offset > 0)
	{
		printf("Warnning::%d Bytes not handled...\n", bufSize-offset);
		exit(0);
	}
	return offset + 1;
}

int main()  
{  
	int sock_fd = socket(AF_INET, SOCK_DGRAM, 0);
  	if(sock_fd < 0)  
  	{  
    		printf("socket created failed.\n");  
    		exit(-1);  
  	}  

    int reuse = 1;
    if(setsockopt(sock_fd, SOL_SOCKET, SO_REUSEADDR, (char*)&reuse, sizeof(reuse)))
    {
        printf("set SO_REUSEADDR failed.\n");
        exit(-1);
    }

  	struct sockaddr_in addr_serv;  
  	int len;  
  	memset(&addr_serv, 0, sizeof(struct sockaddr_in));  
  	addr_serv.sin_family = AF_INET;
  	addr_serv.sin_port = htons(SERV_PORT);
  	addr_serv.sin_addr.s_addr = htonl(INADDR_ANY);  
  	len = sizeof(addr_serv);  
  	 
	struct timeval time_out;
	time_out.tv_sec  = 10;
	time_out.tv_usec = 0;
	if(setsockopt(sock_fd, SOL_SOCKET, SO_RCVTIMEO, &time_out, sizeof(time_out)))
	{
		printf("receive time out set failed.\n");
		exit(-1);
	}

  	if(bind(sock_fd, (struct sockaddr *)&addr_serv, sizeof(addr_serv)) < 0)  
  	{
		printf("bind socket with addr_serv failed.\n");  
  		exit(-1);  
  	}  
  	  
  	int recv_num;  
  	int send_num;  
  	char recv_buf[1024*10];  
  	struct sockaddr_in addr_client;
	int recv_cnt = 0;  
 
	struct ip_mreq group;
 	group.imr_multiaddr.s_addr = inet_addr(MULTI_ADDR);
    //group.imr_interface.s_addr = INADDR_ANY;
    group.imr_interface.s_addr = inet_addr(LOCAL_ADDR);
    if(setsockopt(sock_fd, IPPROTO_IP, IP_ADD_MEMBERSHIP, (char *)&group, sizeof(group)) < 0)
	{
        printf("set multicast group failed.\n");
        close(sock_fd);
        exit(-1);
	}

  	while(1)  
  	{  
  	  	//printf("receiving data...\n");  
  	  	recv_num = recvfrom(sock_fd, recv_buf, sizeof(recv_buf), 0, (struct sockaddr *)&addr_client, (socklen_t *)&len);  
  	  	
		if(recv_num == -1 && errno == EAGAIN)
		{
			printf("receiving data time out...\n");			
  			break;
		}	
		
		else if(recv_num < 0)  
  	  	{  
  	  	  	printf("recvfrom error:");  
  	  	  	exit(-1);  
  	  	}  
  		handleMDMsg(recv_buf,recv_num);
		recv_cnt++;
	}  
  	
	printf("recv_cnt=%d.\n",recv_cnt);  
  	close(sock_fd); 

  	return 0;
} 
