
#include <thread>
#include "ini_parser.h"
#include "struct_data_test.h"

int main(int argc, char* argv[])
{
    remd::IniParser ini;
    if (!ini.Read("config.ini")) 
	{
        printf("read config.ini error.\n");
        return 0;
    }

    std::vector<std::thread> threads;

    //Ϻṹ
    auto section1 = ini.FindSection("shse_struct_data");
    if (section1)
	{
        std::string enable = section1->GetValue("enable");
        if (enable == "1" || enable == "yes") 
		{
            threads.push_back(std::thread([section1]{StructDataTest::Do(section1);}));
        }
    }

    //ڽṹ
    auto section2 = ini.FindSection("szse_struct_data");
    if (section2) {
        std::string enable = section2->GetValue("enable");
        if (enable == "1" || enable == "yes") {
            threads.push_back(std::thread([section2] {StructDataTest::Do(section2); }));
        }
    }

	for (auto& t : threads)
	{
        t.join();
    }
    return 0;
}


