// @Author:   citicsf
// @Date:     2019/11/30
// @Brief:

#ifndef __REMD_REMDAPI_H__
#define __REMD_REMDAPI_H__

#include "REMDApiStruct.h"

#if defined(_MSC_VER) || defined(WIN32) || defined(WIN64) || defined(_WINDOWS)
#ifdef REMD_API_EXPORT
#define CTCSF_REMD_API __declspec(dllexport)
#else
#define CTCSF_REMD_API __declspec(dllimport)
#endif
#else
#define CTCSF_REMD_API __attribute((visibility("default")))
#endif


#ifdef __cplusplus
extern "C" {
#endif

enum REMD_ERROR {
    REMD_ERR_UNKOWN = -200,                // δ֪

    REMD_ERR_INITIALIZE_FAILURE = -100,  // ʼsocketʧ
    REMD_ERR_NETWORK_ERROR,              // ӳ
    REMD_ERR_INVALID_PARAMS,             // Ч
    REMD_ERR_VERIFY_FAILURE,             // ½֤ʧܣԭΪû󣻳½
    REMD_ERR_NO_AUTHORIZED_MARKET,       // гûȨ
    REMD_ERR_NO_CODE_TABLE,              // г춼ûд
    REMD_ERR_IN_REBUILDING,              // ؽδɣǰشʱٴؽ

    REMD_ERR_SUCCESS = 0,                // ɹ
};

// ͬɹ򷵻ؾ򷵻NULL
// REMD_ERRORΪNULL
CTCSF_REMD_API REMDHandle REMD_Open(const REMD_OpenSetting*, REMD_ERROR*);

// ͬɹ򷵻ؾ򷵻NULL
// REMD_ERRORΪNULL
// ӵԭʼݷ
CTCSF_REMD_API REMDHandle REMD_OpenRaw(const REMD_RawOpenSetting*, REMD_ERROR*);

// رվ
CTCSF_REMD_API void REMD_Close(REMDHandle);

// ȡָгĴSH,SZ
// ȡĴҪREMD_Freeͷڴ
CTCSF_REMD_API REMD_ERROR REMD_GetCodeTable(REMDHandle, const char* szMarket,
                                          REMD_CODEINFO** pCodeList,
                                          uint32_t* nCount);

// ȡָ루ʽΪREMD_CodeϸȨϢ
// pOptionָݽ޸ΪӦȨϢ
CTCSF_REMD_API REMD_ERROR REMD_GetOptionCodeInfo(REMDHandle,
                                               const char* szRemdCode,
                                               REMD_OPTION_CODEINFO* pOption);

// ¶Ϣ
// szCodeListΪ{áӡɾ}֤ȯб
// ĸΪREMD_ALLszCodeList
CTCSF_REMD_API REMD_ERROR REMD_UpdateSubscription(REMDHandle,
                                                REMD_SUBSCRIPTION_UPDATE,
                                                const char* szRemdCodeList);

// ߳úغͷţڻصе
CTCSF_REMD_API void REMD_Wait(REMDHandle);

// ͷڴ
CTCSF_REMD_API void REMD_Free(void*);

// 汾
CTCSF_REMD_API const char* REMD_Version();


//////////////////////////////////////////////////////////////////////////
// Ϊȡӿ
// APIµϢֱݻ󷵻
// ˲κλصʹãӦ߳е

//ȡǰ,szMarketSH,SZ,REMD_Free(void*)ͷڴ
CTCSF_REMD_API REMD_ERROR REMD_GetLastMarketData(REMDHandle handle,
                                               const char* szMarket,
                                               REMD_SecuritySnapShot** pMarketData,
                                               int* nCount);

//ȡǰָ,szMarket(SH,SZ),REMD_Free(void*)ͷڴ
CTCSF_REMD_API REMD_ERROR REMD_GetLastIndexData(REMDHandle handle,
                                              const char* szMarket,
                                              REMD_IndexSnapShot** pIndexData,
                                              int* nCount);

//ȡǰڻ/Ȩ,szMarket(SH,SZ),REMD_Free(void*)ͷڴ
CTCSF_REMD_API REMD_ERROR REMD_GetLastFutureData(REMDHandle handle,
                                               const char* szMarket,
                                               REMD_FutureSnapShot** pFutureData,
                                               int* nCount);


////////////////////////////////////////////////////////////////////////////////
// ؽӿ

// ؽṹݣкŷΧ[start, end)
// յݻpfDataHandlerеõ
CTCSF_REMD_API REMD_ERROR REMD_RebuildStructData(REMDHandle,
                                               SeqType start, SeqType end,
                                               REMD_DataHandler pfDataHandler);

// ؽݣкŷΧ[start, end)
// յݻpfDataHandlerеõ
CTCSF_REMD_API REMD_ERROR REMD_RebuildRawData(REMDHandle, REMD_Market,
                                            SeqType start, SeqType end,
                                            REMD_DataHandler pfDataHandler);

#ifdef __cplusplus
}
#endif  // __cplusplus


#endif // __REMD_REMDAPI_H__