// @Author:   citicsf
// @Date:     2019/11/30
// @Brief:

#ifndef __REMD_REMDAPISTRUCT_H__
#define __REMD_REMDAPISTRUCT_H__

#include "stdint.h"


// ϢͶ
enum REMD_MSG_TYPE {
    REMD_MSG_NONE = -1,

    REMD_SYS_UDP_REALTIME_TIMEOUT = 0,      // UDPʵʱͨʱ
    REMD_SYS_TCP_RETRANSMIT_CONNECTED,      // TCPشͨӳɹ
    REMD_SYS_TCP_RETRANSMIT_DISCONNECTED,   // TCPشͨϿ
    REMD_SYS_SERVER_LOGIN,                  // ӷ
    REMD_SYS_CODE_TABLE_UPDATED,            // 
    REMD_SYS_DATA_REBUILD,                  // ؽϢ

    REMD_DATA_INDEX = 100,          // ָ
    REMD_DATA_SECURITY,             // ֤ȯ
    REMD_DATA_FUTURE,               // ڻ/Ȩ
    REMD_DATA_TRADE_DETAIL,         // ʳɽ
    REMD_DATA_ORDER_DETAIL,         // ί
    REMD_DATA_ORDER_QUEUE,          // ίж

    REMD_DATA_EXCHANGE_RAW = 200          // ԭʼ
};

typedef uint64_t SeqType;

struct REMD_MSG {
    //  enum REMD_MSG_TYPE
    int     nDataType;
    // ݳ
    int     nDataLen;
    // ʱȷHHMMSSmmm
    int     nServerTime;
    // IDOpen趨ֵ
    int     nConnectId;
    // кţȫ򣬽ṹݺԭʼݶ
    // Ĳг룬кŻ᲻
    // ڽԭʼݣϺڶţÿմ0ʼ
    SeqType nSequence;
    //ָ
    void* pData;
};

// ӽϢΪ REMD_SYS_TCP_RETRANSMIT_CONNECTED  REMD_SYS_UDP_REALTIME_TIMEOUT
struct REMD_ConnectResult {
    // ӵķַͶ˿ں
    char        szAddress[32];
    uint16_t    nPort;
    uint16_t    nConnectResult;     // Ϊ0ʾʧܣ0ʾӳɹ
};

// ϿϢΪ REMD_SYS_TCP_RETRANSMIT_DISCONNECTED
struct REMD_Disconnect {
    // ӵķַͶ˿ں
    char        szAddress[32];
    uint16_t    nPort;
};

// ¼ϢΪREMD_SYS_SERVER_LOGIN
struct REMD_LoginResult {
    char        szAddress[32];
    uint16_t    nPort;
    uint16_t nLoginResult;       // Ϊ0ʾ½֤ɹ0ʾ֤ʧ
    char     szInfo[128];        // 
    uint16_t nMarkets;           // г
    char     szMarkets[6][8];    // г SZ, SH
};

// £ϢΪREMD_SYS_CODE_TABLE_UPDATED
struct REMD_CodeTableResult {
    char        szInfo[128];         //ı
    int32_t     nMarkets;           //г
    char        szMarket[8][8];    //г
    int32_t     nCodeCount[8];     //
    int32_t     nCodeDate[8];      //
};

// ؽϢϢΪREMD_SYS_DATA_REBUILD
struct REMD_RebuildResult {
    SeqType Start;      // ʼк
    SeqType End;        // к
    uint32_t Status;    // ״̬0ʾشɣ1ʾ2ʾǰһδɣ3ʾشз
};

//
typedef void* REMDHandle;

// Ϣص
typedef void(* REMD_DataHandler)(REMDHandle, const REMD_MSG*);

// ϵͳϢص
typedef void(* REMD_SystemHandler)(REMDHandle, const REMD_MSG*);

// ݶͶ壬Ķʱʹ '|'
// ͬʱʳɽίУ REMD_TRADE_DETAIL | REMD_ORDER_DETAIL
// ΪĬ϶ģΪ0
enum REMD_SUBSCRIBED_DATA_TYPE {
    REMD_DATA_TYPE_SNAPSHOT     = 0x00,         // 
    REMD_DATA_TYPE_TRADE_DETAIL = 0x02,         // ʳɽ
    REMD_DATA_TYPE_ORDER_DETAIL = 0x04,         // ί
    REMD_DATA_TYPE_ORDER_QUEUE  = 0x08          // ίж
};

// ĸͣ{ȫгģΪб֤ȯб֤ȯɾб֤ȯ}
// ںREMD_UpdateSubscriptionʹ
enum REMD_SUBSCRIPTION_UPDATE {
    REMD_ALL, REMD_SET, REMD_ADD, REMD_DEL
};

// 
struct REMD_OpenSetting {
    // IDصϢײд
    int32_t ConnectID;

    // ʵʱݵַͶ˿(UDP鲥ַ)
    char     MulitcastIP[32];
    uint16_t MulitcastPort;
    char     MulitcastInterface[32];

    // شݵַ˿(TCPַ)
    char     RetransmitAddr[32];
    uint16_t RetransmitPort;

    // û
    char UserName[64];
    char Password[64];

    // ݻص & ϵͳ״̬ص
    // յ֮Ӧݻѹ
    REMD_DataHandler   DataHandler;
    REMD_SystemHandler SystemHandler;

    /* ϢСд */
    // ĵĽб;ָΪձʾУĿǰ֧SH,SZ
    const char* SubscribedMarkets;
    // ĵ֤ȯ룬;ָΪձʾУ"600000.SH;000001.SZ"
    const char* SubscribedCodes;
    // ĵͣREMD_SUBSCRIBED_DATA_TYPE
    int32_t SubscribedDataType;
};

// ԭʼ
struct REMD_RawOpenSetting {
    // IDصϢײд
    int32_t ConnectID;

    // IPַ

    // ʵʱݵַͶ˿(UDP鲥ַ)
    char     MulitcastIP[32];
    uint16_t MulitcastPort;
    char     MulitcastInterface[32];

    // شݵַ˿(TCPַ)
    char     RetransmitAddr[32];
    uint16_t RetransmitPort;

    // û
    char UserName[64];
    char Password[64];

    // ݻص & ϵͳ״̬ص
    // յ֮Ӧݻѹ
    REMD_DataHandler   DataHandler;
    REMD_SystemHandler SystemHandler;

    /* ϢСд */
    // ĵĽб;ָΪձʾޣעREMD_OpenSettingͬĿǰ֧SH,SZ
    const char* SubscribedMarkets;
};

///֤ȯԭʼ
typedef char REMD_Code[16];

///ϵͳڲ룬ʽΪԭʼ.г(SH/SZ)
typedef char REMD_RemdCode[32];

///ID
typedef char REMD_Market;

#define REMD_MARKET_NO  '0'
#define REMD_MARKET_SH  '1'
#define REMD_MARKET_SZ  '2'

///
typedef char REMD_OrderType;
// м
#define REMD_ORDER_TYPE_MARKET  '1'
// ޼
#define REMD_ORDER_TYPE_LIMIT   '2'
// 
#define REMD_ORDER_TYPE_AT_BEST  'U'

///
typedef char REMD_OrderSide;

#define REMD_ORDER_SIDE_BID 'B'
#define REMD_ORDER_SIDE_ASK 'S'
#define REMD_ORDER_SIDE_G 'G'
#define REMD_ORDER_SIDE_F 'F'

///ɽ
typedef char REMD_ExecType;

#define REMD_EXEC_TRADE 'T'
#define REMD_EXEC_CANCEL 'C'

///BSǣ{̡̡δ֪}
typedef char REMD_BSFlag;

#define REMD_BSFLAG_B  'B'
#define REMD_BSFLAG_S  'S'
#define REMD_BSFLAG_N  ' '

///״̬
typedef char REMD_TradingStatus;

///
struct REMD_CODEINFO {
    REMD_Code     szCode;			///֤ȯ
    REMD_Market   nMarket;          ///ID
    REMD_RemdCode szRemdCode;		///ϵͳڲ
    char          szCNName[32];     ///֤ȯ
    int           nType;            ///֤ȯļβ
};

///Ȩ
struct REMD_OPTION_CODEINFO {
    ///Ϣ
    REMD_CODEINFO basicCode;
    ///ȨԼ
    char          szContractID[32];
    ///֤ȯ
    char          szUnderlyingSecurityID[32];
    ///ϹϹϹCϹP
    char          chCallOrPut;
    ///ȨȨգYYYYMMDD
    int           nExerciseDate;
    ///֤ȯͣAɣ0ETF1
    char          chUnderlyingType;
    ///ŷʽʽŷʽȨEʽȨA
    char          chOptionType;
    ///ǵͣǵͣN, ǵͣR
    char          chPriceLimitType;
    ///ԼλȨϢĺԼλһ
    int           nContractMultiplierUnit;
    ///ȨȨۣȨϢȨȨۣҶ룬ȷ
    int64_t       nExercisePrice;
    ///Ȩ׸գYYYYMMDD
    int           nStartDate;
    ///Ȩ/ȨգYYYYMMDD
    int           nEndDate;
    ///ȨգYYYYMMDD
    int           nExpireDate;
};

///
struct REMD_SecuritySnapShot {
    REMD_Code   szCode;               ///֤ȯ
    REMD_Market nMarket;                  ///ID
    int32_t     nActionDay;               ///ҵ(Ȼ)
    int32_t     nTradingDay;              ///
    int32_t     nTime;                      ///ʱ(HHMMSSmmm)
    int32_t     nStatus;                  ///ǰ֤ȯ״̬REMD_TradingStatus
    int64_t     nPreClose;                ///ǰ̼
    int64_t     nOpen;                    ///̼
    int64_t     nHigh;                    ///߼
    int64_t     nLow;                     ///ͼ
    int64_t     nMatch;                   ///¼
    int64_t     nAskPrice[10];            ///
    int64_t     nAskVol[10];              ///
    int64_t     nBidPrice[10];            ///
    int64_t     nBidVol[10];              ///
    int32_t     nNumTrades;               ///ɽ
    int64_t     iVolume;                  ///ɽ
    int64_t     iTurnover;                ///ɽܽ
    int64_t     nTotalBidVol;             ///ί
    int64_t     nTotalAskVol;             ///ί
    int64_t     nWeightedAvgBidPrice;     ///Ȩƽί۸
    int64_t     nWeightedAvgAskPrice;     ///Ȩƽί۸
    int32_t     nIOPV;                    ///IOPVֵֵ
    int32_t     nYieldToMaturity;         ///
    int64_t     nHighLimited;             ///ͣ
    int64_t     nLowLimited;              ///ͣ
    int32_t     nSyl1;                    ///ӯ1
    int32_t     nSyl2;                    ///ӯ2
    int32_t     nSD1;                     ///1
    int32_t     nSD2;                     ///2
    int64_t     iAfterPrice;              ///̺۸(ƴ)
    int64_t     nAfterVolume;             ///̺(ƴ)
    int64_t     iAfterTurnover;           ///̺ɽ(ƴ)
    int64_t     nAfterMatchItems;         ///̺ɽ(ƴ)
    int64_t     nReserve;                 ///Ԥλ
};


///ָ
struct REMD_IndexSnapShot {
    REMD_Code   szCode;						///֤ȯ
    REMD_Market nMarket;					///ID
    int32_t     nActionDay;					///ҵ(Ȼ)
    int32_t     nTradingDay;				///
    int32_t     nTime;                      ///ʱ(HHMMSSmmm)
    int64_t     nPreCloseIndex;				///ǰָ
    int64_t     nOpenIndex;					///ָ
    int64_t     nHighIndex;					///ָ
    int64_t     nLowIndex;					///ָ
    int64_t     nLastIndex;					///ָ
    int64_t     iTotalVolume;				///ӦָĽ
    int64_t     iTurnover;					///Ӧָĳɽ
};

///ίж
struct REMD_OrderQueue {
    REMD_Code      szCode;                   ///֤ȯ
    REMD_Market    nMarket;                      ///ID
    int32_t        nActionDay;                   ///ҵ(Ȼ)
    int32_t        nTradingDay;                  ///
    int32_t        nTime;                          ///ʱ(HHMMSSmmm)
    REMD_OrderSide nSide;                        ///
    int64_t        nPrice;                       ///ίм۸
    int32_t        nOrders;                      ///
    int32_t        nABItems;                     ///ίжи
    int32_t        nABVolume[200];               ///ίϸ
};

///ί
struct REMD_OrderDetail {
    REMD_Code      szCode;                  ///֤ȯ
    REMD_Market    nMarket;                     ///ID
    int32_t        nActionDay;                     ///ί(YYMMDD)
    int32_t        nTime;                         ///ίʱ(HHMMSSmmm)
    uint64_t       nOrder;                      ///ίк
    int64_t        nPrice;                      ///ίм۸
    int32_t        nVolume;                     ///ί
    REMD_OrderSide nOrderSide;                  ///
    REMD_OrderType nOrderType;                  ///
};

///ʳɽ
struct REMD_TradeDetail {
    REMD_Code     szCode;					   ///֤ȯ
    REMD_Market   nMarket;                     ///ID
    int32_t       nActionDay;                  ///Ȼ
    int32_t       nTime;                       ///ɽʱ(HHMMSSmmm)
    uint64_t      nIndex;                      ///ɽ
    int64_t       nPrice;                      ///ɽ۸
    int32_t       nVolume;                     ///ɽ
    int64_t       nTurnover;                   ///ɽ
    uint64_t      nAskOrder;                   ///ί
    uint64_t      nBidOrder;                   ///ί
    REMD_ExecType nExecType;                   ///ɽ
    REMD_BSFlag   nBSFlag;                     ///
};

///ڻ飬ĿǰֻṩȨ
struct REMD_FutureSnapShot {
    REMD_Code   szCode;               ///֤ȯ
    REMD_Market nMarket;                  ///ID
    int32_t     nActionDay;               ///ҵ(Ȼ)
    int32_t     nTradingDay;              ///
    int32_t     nTime;                      ///ʱ(HHMMSSmmm)
    int32_t     nStatus;                  ///ǰ֤ȯ״̬REMD_TradingStatus
    int64_t     iPreOpenInterest;        ///ֲ
    int64_t     nPreClose;               ///̼
    int64_t     nPreSettlePrice;         ///
    int64_t     nOpen;                   ///̼
    int64_t     nHigh;                   ///߼
    int64_t     nLow;                    ///ͼ
    int64_t     nMatch;                  ///¼
    int64_t     iVolume;                 ///ɽ
    int64_t     iTurnover;               ///ɽܽ
    int64_t     iOpenInterest;           ///ֲ
    int64_t     nClose;                  ///
    int64_t     nSettlePrice;            ///
    int64_t     nHighLimited;            ///ͣ
    int64_t     nLowLimited;             ///ͣ
    int32_t     nPreDelta;               ///ʵ
    int32_t     nCurrDelta;              ///ʵ
    int64_t     nAskPrice[5];            ///
    int64_t     nAskVol[5];              ///
    int64_t     nBidPrice[5];            ///
    int64_t     nBidVol[5];              ///
    int64_t     nAuctionPrice;           ///жϲο
    int64_t     nAuctionQty;             ///жϼϾƥ
};

///ԭʼ
struct REMD_RawData {
    REMD_Market nMarket;    // ID
    uint32_t    RawDataLength; // ԭʼĳ
    const char* RawData;    // ԭʼ
};

#endif // __REMD_REMDAPISTRUCT_H__